import { Tag } from "../util";
export class TreeFinderFiltersElement extends HTMLElement {
    constructor() {
        super(...arguments);
        this._initialized = false;
        // private _initializedListeners: boolean = false;
    }
    clear() {
        this.innerHTML = `<tree-finder-filter></tree-finder-filter>`.repeat(this.model.columns.length + 1);
        this.filters = [...this.children];
    }
    connectedCallback() {
        if (!this._initialized) {
            this.create_shadow_dom();
            this._initialized = true;
        }
        // if (!this._initializedListeners) {
        //   this.addEventListener("mouseup", event => this.onClick(event));
        //   this._initializedListeners = true;
        // }
    }
    init(model) {
        if (!this._initialized) {
            this.create_shadow_dom();
            this._initialized = true;
        }
        this.model = model;
        this.clear();
        for (const [index, element] of this.filters.entries()) {
            element.init(model, index);
        }
    }
    create_shadow_dom() {
        this.attachShadow({ mode: "open" });
        const filterSlot = `<slot></slot>`;
        this.shadowRoot.innerHTML = Tag.html `
      <style>
      </style>
      <div class="tf-filters-top">
        ${filterSlot}
      </div>
    `;
        [this.shadowSheet, this.top] = this.shadowRoot.children;
    }
    entries() {
        return this.filters.entries();
    }
    getChild(ix) {
        return this.filters[ix];
    }
    getInput(ix) {
        var _a;
        return (_a = this.getChild(ix)) === null || _a === void 0 ? void 0 : _a.input;
    }
}
// export namespace TreeFinderFiltersElement {
// }
customElements.define("tree-finder-filters", TreeFinderFiltersElement);
//# sourceMappingURL=filters.js.map